/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *  launch.c -- launch or undock a ship (also undock)
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "buffers.h"
#include <signal.h>


int launch_shdata,launch_pdata,launch_stdata;

launch(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int sh, sh2, sh3;
shiptype *s,*s2,*s3;
planettype *p;
boolean planet=0;
int shipno;
float fuel;

launch_shdata = launch_pdata = NEUTRAL_FD;

	sscanf(args[1]+(args[1][0]=='#'),"%d",&shipno);

  openshdata(&launch_shdata);
  if (!getship(launch_shdata, &s, shipno)) {
      close_file(launch_shdata);
      return;
  }
close_file(launch_shdata);


  if (s->owner!=Playernum) {
	DontOwnErr(Playernum,shipno);
	return;
  }
  if (!speed_rating(s)) {
	sprintf(buf,"That ship is not designed to be launched.\n");
		notify(Playernum, buf);
	return;
  }


  if (testship(Playernum,s,shipno)) {
	return;
	}

  if (!s->is_docked) {
	sprintf(buf,"Ship #%d is not landed or docked.\n",shipno);
		notify(Playernum, buf);
	return;
  }
  if (s->whatdest==LEVEL_PLAN && s->resource > Max_resource(s)) {
	sprintf(buf,"Ship #%d is too overloaded to launch.\n", shipno);
		notify(Playernum, buf);
	return;
  }

  if (s->whatdest==LEVEL_SHIP) {
      openshdata(&launch_shdata);
	(void)getship(launch_shdata, &s2, s->destshipno);
      close_file(launch_shdata);
  	if (s2->whatorbits==LEVEL_UNIV) {
	  if (!enufAP(Playernum,Sdata.AP[Playernum-1], APcount)) { 
		return;
	 } else
  		deductAPs(Playernum,APcount, 0, 1);
  	} else {
	  if (!enufAP(Playernum,Stars[s->storbits]->AP[Playernum-1], APcount)) {
		return;
	  } else
  		deductAPs(Playernum,APcount, s->storbits, 0);
	}

	if( !(s->type == STYPE_FIGHTER && s2->type == STYPE_CARRIER) )
		{
	s->is_docked = 0;
	s->whatdest = LEVEL_UNIV;
	sh2 = s->destshipno;
	s->destshipno = 0;
	openshdata(&launch_shdata);
	putship(launch_shdata, s, shipno);

	s2->is_docked = 0;
	s2->whatdest = LEVEL_UNIV;
	s2->destshipno = 0;
	putship(launch_shdata, s2, sh2);
	close_file(launch_shdata);
	free(s);
	free(s2);
		} else {   /* fighters docked with carriers */

	/* fix carrier linked list */
	sh = s2->object.number;
	if(sh == shipno) {
		s2->object.number = s->object.number;
		} else {
openshdata(&launch_shdata);
	while(sh != shipno) {

		(void)getship(launch_shdata, &s3, sh);
	sh3 = sh;
	sh = s3->object.number;
		}

	s3->object.number = s->object.number; /* change pointer */
	putship(launch_shdata, s3, sh3);
	close_file(launch_shdata);
    }

	/* fighter is on its own */
	s->is_docked = 0;
	s->whatdest = LEVEL_UNIV;
	s->whatorbits = s2->whatorbits;
	s->object.number = 0;
	s->object.number4 = 0;
	sh2 = s->destshipno;
	s->destshipno = 0;
	s->xpos = s2->xpos;
	s->ypos = s2->ypos;
	s->storbits = s2->storbits;
	s->pnumorbits = s2->pnumorbits;

	s2->mass -= s->mass; /* carrier is lighter */
	s2->object.number4 -= 1;
/* put fighter into the appropriate linked list (planet/star/universe).
   it is put into the level of the carrier */

	if(s2->whatorbits==LEVEL_PLAN)
	{
  
  openpdata(&launch_pdata);
  getplanet(launch_pdata, &p, Stars[s2->storbits]->planetpos[s2->pnumorbits]);
	s->nextship = p->ships;
	p->ships = shipno;
  putplanet(launch_pdata,p,Stars[s2->storbits]->planetpos[s2->pnumorbits]);
  	close_file(launch_pdata);
	}
	if(s2->whatorbits==LEVEL_STAR)
	{
  openstardata(&launch_stdata);
  getstar(launch_stdata, &Stars[s2->storbits],s2->storbits);
	s->nextship = Stars[s2->storbits]->ships;
	Stars[s2->storbits]->ships = shipno;
  putstar(launch_stdata, Stars[s2->storbits],s2->storbits);
	close_file(launch_stdata);
	}

	openshdata(&launch_shdata);
	putship(launch_shdata, s, shipno);
	putship(launch_shdata, s2, sh2);
	close_file(launch_shdata);

	free(s);
	free(s2);
	free(s3);
			}


	sprintf(buf,"%s #%d undocked from %s #%d.\n", 
		Shipnames[s->type], shipno, Shipnames[s2->type],sh2);
		notify(Playernum, buf);

  } else {

	  if (!enufAP(Playernum,Stars[s->storbits]->AP[Playernum-1], APcount)) { 
		return;
	  } else
  		deductAPs(Playernum,APcount, s->storbits, 0);

  s->is_docked = 0;
  s->whatdest = LEVEL_UNIV;	/* no destination */


	/* adjust x,ypos to absolute coords */
  openpdata(&launch_pdata);
  getplanet(launch_pdata, &p, Stars[s->storbits]->planetpos[s->pnumorbits]);
  close_file(launch_pdata);

  sprintf(buf,"Planet /%s/%s has gravity field of %.2f\n", Stars[s->storbits]->name,
	Stars[s->storbits]->pnames[s->pnumorbits], gravity(p));
		notify(Playernum, buf);
   /* alter sector location of ship x,y to stellar coords x,y */
  s->xpos = Stars[s->storbits]->xpos + p->xpos + 
		(float)int_rand((int)(-DIST_TO_LAND/4),(int)(DIST_TO_LAND/4));
  s->ypos = Stars[s->storbits]->ypos + p->ypos + 
		(float)int_rand((int)(-DIST_TO_LAND/4),(int)(DIST_TO_LAND/4));

   /* subtract fuel from ship */
  fuel = gravity(p) * s->mass * LAUNCH_GRAV_MASS_FACTOR;
  if (s->fuel < fuel) {
	sprintf(buf,"Ship #%d does not have enough fuel! (%.1f)\n",shipno, fuel);
		notify(Playernum, buf);
	return;
  }
  s->fuel -= fuel;
  s->mass -= fuel * MASS_FUEL;


  if (s->type == OTYPE_CANIST)
	s->object.number = 80;	/* canister dissapates after 20 turns */

  s->notified = 0;
openshdata(&launch_shdata);
	  putship(launch_shdata, s, shipno);
  close_file(launch_shdata);

  if (!p->is_explored) {
		/* not yet explored by owner; space exploration causes the
		   player to see a whole map */
	p->is_explored = 1;
openpdata(&launch_pdata);
  	putplanet(launch_pdata,p,Stars[s->storbits]->planetpos[s->pnumorbits]);
  	close_file(launch_pdata);
  }
  free(p);

  sprintf(buf,"%s #%d %s launched from planet,", Shipnames[s->type], shipno, s->name);
		notify(Playernum, buf);
  sprintf(buf," using %.1f fuel.\n",fuel);
 		notify(Playernum, buf);
 if (s->type == OTYPE_CANIST) {
		notify(Playernum, buf);
	sprintf(buf, "A thick cloud of dust envelops your planet.\n");
		notify(Playernum, buf); 
	}

  free(s);

  }

}


