/*
** Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
** smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
** Restrictions in GB_copyright.h.
**
**  move.c -- move population and assault aliens on target sector
*/

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>
#include <math.h>
#include <signal.h>

int move_sectdata,move_pdata, move_racedata;
int Defensedata[] = { 1, 1, 3, 2, 2, 4};
extern char *Desnames[];

move_popn(Playernum,APcount,argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int Assault;	/* unfriendly movement */
int casualties,casualties2;

char c;
planettype *planet;
sectortype *sect,*sect2,*dummy;
racetype *alien;
boolean legal,planetmod=0,sectmod=0;
int people,oldpopn,old2popn,x= -1,y= -1,x2= -1,y2= -1,i,mask;
int old2owner, absorbed;
float fuel,astrength,dstrength,pris;

move_sectdata = move_pdata = NEUTRAL_FD;

if(!(Dir[Playernum-1].level==LEVEL_PLAN))
	{
		sprintf(buf,"Wrong scope\n");
		return;
	}

free(Race);
openracedata(&move_racedata);
getrace(move_racedata, &Race, Playernum);
close_file(move_racedata);

openpdata(&move_pdata);
getplanet(move_pdata,&planet,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
close_file(move_pdata);

if (planet->slaved_to>0 && planet->slaved_to != Playernum) {
	sprintf(buf,"That planet has been enslaved!\n");
			notify(Playernum, buf);		
	return;
}

	sscanf(args[1],"%d,%d",&x,&y);
	if(x < 0 || y < 0 || x > planet->Maxx-1 || y > planet->Maxy-1){
		sprintf(buf,"Illegal coordinates.\n");
			notify(Playernum, buf);
			return;
		}

	opensectdata(&move_sectdata);
	getsector(move_sectdata,&sect,planet->sectormappos+(y*planet->Maxx+x)*
		sizeof(sectortype));

	if(sect->owner != Playernum) {
	sprintf(buf,"You don't own sector %d,%d!\n",x,y);
			notify(Playernum, buf);
	close_file(move_sectdata);
		return;
	}
	close_file(move_sectdata);	

	sscanf(args[2],"%d,%d",&x2,&y2);

	if(x2 < 0 || y2 < 0 || x2 > planet->Maxx-1 || y2 > planet->Maxy-1){
		sprintf(buf,"Illegal coordinates.\n");
			notify(Playernum, buf);
			return;
		}


/* check to see if the move is legal */
     legal = 1;
if(abs(y-y2) > 1) legal = 0;
else if(x==x2 && y==y2) legal = 0;
else {
if(!((x == 0 && x2 == planet->Maxx-1) ||
     (x == planet->Maxx-1 && x2 == 0) ||
     (abs(x-x2) <= 1)) )  legal = 0;
}

if(!legal) {
  sprintf(buf,"Illegal move - to adjacent sectors only!\n");
		notify(Playernum, buf);
	return;
}

/* ok, the move is legal */
	opensectdata(&move_sectdata);
	getsector(move_sectdata,&sect2,planet->sectormappos+(y2*planet->Maxx+x2)*
		sizeof(sectortype));

	close_file(move_sectdata);	

if(argn >= 4)
    sscanf(args[3],"%d",&people);
else
    people = sect->popn;


if(people > sect->popn || people <= 0) {
	sprintf(buf,"Illegal value - max is %d\n", sect->popn);
		notify(Playernum, buf);
	return;
	}
if(argn < 4) {
    sprintf(buf, "%d population being moved.\n", people);
    notify(Playernum, buf);
}


if(sect2->owner > 0 && sect2->owner != Playernum)
	Assault = 1;
else
	Assault = 0;

if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount))
	return;
	
	if (Assault) {
		sprintf(buf,"Assault!\n");
		notify(Playernum, buf);

	openracedata(&move_racedata);
		getrace(move_racedata, &alien, sect2->owner);
	close_file(move_racedata);

/* races find out about each other */
	alien->translate[Playernum-1] = MIN(alien->translate[Playernum-1]+5, 100);
	Race->translate[sect2->owner-1] = MIN(Race->translate[sect2->owner-1]+5, 100);

		old2owner = sect2->owner;
		sect->popn -= people;
		sprintf(buf,"%d attackers (fighting = %d) vs. %d defenders (fighting = %d)\n",
			people,Race->fighters,sect2->popn,alien->fighters);
			notify(Playernum, buf);
		sprintf(buf,"Attack strength: %.2f   Defense strength: %.2f.\n", 

/* combat proportional to population - other factors are modifiers */
		   astrength = 0.1 * people * log10(Race->fighters
			* (Race->tech+1.0) * (sect->mobilization+1)
			* (Race->likes[sect->des]+1.0) *
 			(sect->is_wasted ? 0 : Defensedata[sect->des]) + 10),


		   dstrength = 0.1 * sect2->popn * log10(alien->fighters
			* (alien->tech+1.0) * (sect2->mobilization+1)
			* (alien->likes[sect2->des]+1.0) *
 			(sect2->is_wasted ? 0 : Defensedata[sect2->des]) + 10)
			);
		notify(Playernum, buf);


		 /* nuke both populations */

		oldpopn = people;
		casualties = MIN(oldpopn, int_rand(0,
			 round_rand((float)oldpopn * dstrength / astrength)));
		people -= casualties;


		   old2popn = sect2->popn;
		   casualties2 = MIN(old2popn, int_rand(0,
	       		 round_rand((float)old2popn * astrength / dstrength)));
		   sect2->popn -= casualties2;

if(people > oldpopn) people = 0;
if(sect2->popn > old2popn) sect2->popn = 0; /* bug happens sometimes */

		   if (sect2->popn == 0) {	 /* we got 'em */
			sect2->owner = Playernum;
/* mesomorphs absorb the bodies of their victims */
			absorbed = 0;
			if(Race->Thing) {
				absorbed = int_rand(0, old2popn);
		sprintf(buf, "%d alien bodies absorbed.\n", absorbed);
		notify(Playernum, buf);
		sprintf(buf, "Mesomorphs have absorbed %d bodies!!!\n", absorbed);
		notify(old2owner, buf);
				}
				sect2->popn = people+absorbed;
		   } else {		/* retreat */
			absorbed = 0;
			if(alien->Thing) {
				absorbed = int_rand(0, oldpopn-people);				
				sprintf(buf, "%d alien bodies absorbed.\n", absorbed);
				notify(old2owner, buf);
				sprintf(buf, "Mesomorphs have absorbed %d bodies!!!\n", absorbed);
				notify(Playernum, buf);
				sect2->popn += absorbed;
				}
			sect->popn += people;
		   }


		sprintf(telegram_buf,"Assaulted by%s %s [%d] at %s/%s!!!\n",
			(isset(alien->allied,Playernum) ? " your ally" :
				(isset(alien->atwar,Playernum) ? " your enemy" : "")),
				Race->name, Playernum,
			Stars[Dir[Playernum-1].snum]->name,
			Stars[Dir[Playernum-1].snum]->pnames[Dir[Playernum-1].pnum]);

		sprintf(buf,"Sector %d,%d (%s) attacked from sector %d,%d (%s)\n",
			x2,y2,Desnames[sect2->des],x,y,Desnames[sect->des]);
			str_cat(telegram_buf, buf);

		if (sect2->owner==Playernum) {
			sprintf(buf,"VICTORY! The sector is yours!\n");
				notify(Playernum, buf);
			sprintf(buf,"Sector CAPTURED!\n");
				str_cat(telegram_buf, buf);
			if (astrength/dstrength > 5) {
				 /* not really exclusive but so what*/
				 pris = round_rand(astrength/dstrength);
				 pris = MIN(pris, old2popn);
				 if (Race->captured_prisoners[old2owner-1]<100)
				   Race->captured_prisoners[old2owner-1]++;
				sprintf(buf,"1 prisoner captured!\n");
					notify(Playernum, buf);
				sprintf(buf,"1 prisoner captured!\n");
					str_cat(telegram_buf, buf);
			}
			if (people) {
			  sprintf(buf,"%d critters move in.\n", people);
				notify(Playernum, buf);
					}
		} else {
			sprintf(buf,"The invasion was repulsed; try again.\n");
				notify(Playernum, buf);
			sprintf(buf,"You fought them off!\n");
				str_cat(telegram_buf, buf);
		}

		if (sect->popn + people == 0) {
			sprintf(buf,"You killed all of them!\n");
			str_cat(telegram_buf, buf);
/* increase modifier */
	Race->translate[old2owner-1] = MIN(Race->translate[old2owner-1]+5, 100);
			}

		if (people==0) {
			sprintf(buf,"Oh no! They killed your party to the last man!\n");
				notify(Playernum, buf);
/* increase modifier */
	alien->translate[Playernum-1] = MIN(alien->translate[Playernum-1]+5, 100);
			}

		openracedata(&move_racedata);
				putrace(move_racedata, Race);
				putrace(move_racedata, alien);
		close_file(move_racedata);

		sprintf(buf,"Casualties: Yours: %d, Theirs: %d\n", casualties2,casualties);
			str_cat(telegram_buf, buf);
				if(!notify(old2owner, telegram_buf))
					push_message(TELEG_PLAYER_AUTO, old2owner, telegram_buf);

		sprintf(buf,"Casualties: Yours: %d, Theirs: %d\n", casualties, casualties2);
				notify(Playernum, buf);

	} else {
	  sect->popn -= people;
	  sect2->popn += people;
	  if(sect2->owner == 0)
	    sect2->owner = Playernum;
	}

if(sect->popn == 0)
  sect->owner = 0;

if(sect2->popn == 0)
  sect2->owner = 0;
	
	opensectdata(&move_sectdata);
	getsector(move_sectdata,&dummy,planet->sectormappos);
                        /* turns on lock */

	putsector(move_sectdata,sect,planet->sectormappos+(y*planet->Maxx+x)*
		sizeof(sectortype));
	putsector(move_sectdata,sect2,planet->sectormappos+(y2*planet->Maxx+x2)*
		sizeof(sectortype));


	close_file(move_sectdata);	
deductAPs(Playernum,APcount+Assault, Dir[Playernum-1].snum, 0);

openracedata(&move_racedata);
putrace(move_racedata, Race);
close_file(move_racedata);

}



