/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *  miscellaneous stuff included in the shell
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "races.h"
#include "ships.h"
#include "buffers.h"
#include <curses.h>
#include <signal.h>
#include <ctype.h>
#include <stdio.h>
int shl_racedata;

DontOwnErr(Playernum,shipno)
int Playernum;
reg int shipno;
{
  sprintf(buf,"You don't own ship #%d.\n",shipno);
	notify(Playernum, buf);
}


int enufAP(Playernum,AP, x)
unsigned short AP;
reg int x;
{
 reg int blah;

 if (blah = (AP < x) ) {
	sprintf(buf,"You don't have %d action points there.\n", x);
 	notify(Playernum, buf);
}
 return (!blah);
}


int Getracenum(login)
reg char *login;
{
 reg int i = 0;
 char s[LOGIN_NAME_SIZE];
 FILE *fd;

 fd = fopen(PLAYERDATAFL, "r");
 s[0] = '\0';

 while (!feof(fd) && strcmp(s,login) ) {
   i++;
   fscanf(fd,"%s",s);
 }
 fclose(fd);
 return( (strcmp(s,login)) ? 0 : i );
}


/* returns player # from string containing that players name or #. */

GetPlayer(name, rnum, race)
char *name;
int *rnum;
racetype **race;
{
int numraces;
register int i,l;

	numraces = Numraces();
	*rnum = 0;

	if (isdigit(*name)) {
		if ( (*rnum = atoi(name)) < 1 || *rnum > numraces) {
			*rnum = -1;
			return;
		} else {
	openracedata(&shl_racedata);
			getrace(shl_racedata, race, *rnum);
	close_file(shl_racedata);
			return;
		}
	} else {
		l = strlen(name);
	openracedata(&shl_racedata);
		for (i=1; !(*rnum) && i<=numraces; i++) {
			getrace(shl_racedata, race, i);
			if (!strncmp(name, (*race)->name, l)) {
				*rnum = i;
			close_file(shl_racedata);
				return;
			} else
				free(*race);
		}
	close_file(shl_racedata);
		*rnum = -1;
	}
}

int allocateAPs(Playernum, APcount, argn, args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int maxalloc,stardatafile,mask;
int alloc;

if(Dir[Playernum-1].level == LEVEL_UNIV)
  {
   sprintf(buf,"Change scope to the system you which to transfer global APs to.\n");
	notify(Playernum, buf);
   return;
  }
alloc = atoi(args[1]);
if(alloc <= 0) {
    notify(Playernum, "You must specify a positive amount of APs to allocate.\n");
    return;
}

openstardata(&stardatafile);
getsdata(stardatafile,&Sdata);
maxalloc = MIN(Sdata.AP[Playernum-1],LIMIT_APs-
		Stars[Dir[Playernum-1].snum]->AP[Playernum-1]);
if(alloc>maxalloc)
  {
    sprintf(buf,"Illegal value (%d) - maximum = %d\n", alloc,maxalloc);
	notify(Playernum, buf);
    close_file(stardatafile);
    return;
    }
Sdata.AP[Playernum-1] -= alloc;
     putsdata(stardatafile,&Sdata);
     getstar(stardatafile, &Stars[Dir[Playernum-1].snum], Dir[Playernum-1].snum);
Stars[Dir[Playernum-1].snum]->AP[Playernum-1] = MIN(99,Stars[Dir[Playernum-1].snum]->AP[Playernum-1]
				      +alloc);
     putstar(stardatafile, Stars[Dir[Playernum-1].snum], Dir[Playernum-1].snum);
  close_file(stardatafile);
	sprintf(buf,"Allocated\n");
	notify(Playernum, buf);
}


int deductAPs(Playernum, n, snum, sdata)
int n, snum, Playernum;
int sdata;	/* whether or not sdata is involved */
{
 int deductAPs_stardata, mask;

 if (n) {

  openstardata(&deductAPs_stardata);

  if (!sdata) {
      free(Stars[snum]);
      getstar(deductAPs_stardata, &Stars[snum], snum);

     if (Stars[snum]->AP[Playernum-1] >= n)
	     Stars[snum]->AP[Playernum-1] -= n;
     else {
	Stars[snum]->AP[Playernum-1] = 0;
	sprintf(buf,"WHOA!  You cheater!  Oooohh!  OOOOH!\n  I'm tellllllllliiiiiiinnnnnnnnnggggggggg!!!!!!!\n");
		notify(Playernum, buf);
     }

     putstar(deductAPs_stardata, Stars[snum], snum);

     if (Dir[Playernum-1].level!=LEVEL_UNIV && Dir[Playernum-1].snum == snum) {
         /* fix the prompt */
       sprintf(Dir[Playernum-1].prompt + 5, "%02d", Stars[snum]->AP[Playernum-1]);
       Dir[Playernum-1].prompt[7] = ']';		/* fix bracket (made '\0' by sprintf)*/
     }
  } else {
     getsdata(deductAPs_stardata,&Sdata);
     Sdata.AP[Playernum-1] -= n;
     	if (Sdata.AP[Playernum-1] < 0)
	     Sdata.AP[Playernum-1] = 0;
     putsdata(deductAPs_stardata,&Sdata);

     if (Dir[Playernum-1].level==LEVEL_UNIV) {
       sprintf(Dir[Playernum-1].prompt + 2, "%02d", Sdata.AP[Playernum-1]);
       Dir[Playernum-1].prompt[3] = ']';
     }
  }
  close_file(deductAPs_stardata);
 }

}

void dots(i)
reg int i;
{
reg int j;

  for (j=0; j<i; j++)
	putchar('.');
  for (j=0; j<i; j++)
	putchar('\010');	/* ^H */
}



/* tty stuff -- set cbreak mode */
tty_on()
{
#ifdef VER_4_3
	cbreak();
#else			/* this is 4.2 */
 	crmode();
#endif

}

tty_off()
{
#ifdef VER_4_3
	nocbreak();
#else
	nocrmode();
#endif
}


/* lists all ships in current scope for debugging purposes */
list(Playernum)
int Playernum;
{
shiptype *ship;
planettype *p;
int sh;
int fix_stardata, fix_shdata, fix_pdata, fix_sectdata;
 
 switch(Dir[Playernum-1].level) {
    case LEVEL_UNIV:
	sh = Sdata.ships;
	break;
    case LEVEL_STAR:
	openstardata(&fix_stardata);
	getstar(fix_stardata, &Stars[Dir[Playernum-1].snum], Dir[Playernum-1].snum);
	close_file(fix_stardata);
	sh = Stars[Dir[Playernum-1].snum]->ships;
	break;
    case LEVEL_PLAN:
	openpdata(&fix_pdata);
	getplanet(fix_pdata, &p, Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
	close_file(fix_pdata);
	sh = p->ships;
	break;
    case LEVEL_SHIP:
	sh = Dir[Playernum-1].shipno;
	break;
 }

 openshdata(&fix_shdata);

 while (sh) {
	getship(fix_shdata,&ship,sh);

	sprintf(buf, "%15s #%d '%s' (pl %d) -> #%d %s\n",Shipnames[ship->type],
		sh,ship->name,ship->owner,ship->nextship,
		ship->is_alive ? "" : "(dead)");
	notify(Playernum, buf);
	sh = ship->nextship;
	free(ship);
 }

 close_file(fix_shdata);

}


